/*****************************************************************************
*
* PROGRAM DEMONSTRACYJNY W C++ POKAZUJACY W OPENGL: 
*   - naturalny ruch powierzchni wody (rozchodzace sie fale)
*   - wygodny do uzycia sposob poruszania kamera, ktora podaza do 
*     wyznaczonego celu
*   - znieksztalcanie tekstury na obrazku
*
* Potrzebne pliki:
* demo.c - ten plik, czyli glowny do kompilacji
* sc_fale.h - czesc glowna, z obliczeniami i rysowaniem
* tex.h i stexture.h - wczytywanie i obsluga tekstur (czesciowo zapozyczone
*                      z innych programow)
* funkcje.h - kilka dodatkowych funkcji obliczajacych
* dno.bmp i niebonrm.bmp - bitmapy z teksturami
* glut32.dll - biblioteka GLUT do obslugi OpenGL dla Windows
*
* Kompilacja testowana w Borland C++ Compiler 5.5.
*
* Program ten to FREEWARE. Mozna go rozprowadzac i modyfikowac w dowolny
* sposob. Jesli zostanie wykorzystana jego czesc, bede wdzieczny za 
* umieszczenie w swoim programie informacji o wykorzystaniu oraz powiadomienie
* mnie mailowo, zebym mogl obejrzec efekty, jakie dzieki temu uzyskaliscie :)
*
* W przypadku rozprowadzania tego kodu, prosze o nie usuwanie informacji
* o autorze.
*
* Autor: Grzegorz Drozd
*        Zombie Mastah Prodakshans
*        gad@gad.art.pl
*        http://gad.art.pl/
*
*****************************************************************************/

#include <GL/glut.h>
#include <math.h>
#include <stdlib.h>

#include "stexture.h"
#include "tex.h"
#include "funkcje.h"

GLfloat kamera[3][3], jestkamera[3][3];
GLfloat szybkosckamery=10;

GLfloat aspektratio;

#include "sc_fale.h"

//----------------------------------------------------------------------------
// odswiezenie ustawien ekranu
//----------------------------------------------------------------------------
void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	aspektratio = (GLfloat) w/ (GLfloat) h;
	gluPerspective(70.0, aspektratio, 0.2, 3000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
};


//----------------------------------------------------------------------------
// funkcje klawiatury
//----------------------------------------------------------------------------
void Keyboard(unsigned char key, int x, int y)
{
	switch (key)
	{
		case 27:
			exit(1);
		break;

		default: 		
		break;
	}
}

//----------------------------------------------------------------------------
// obliczenia w kazdej klatce animacji
//----------------------------------------------------------------------------
void OnTimer(int value)
{
	glutTimerFunc(40, OnTimer, 0);

	fale_ruch();

    glutPostRedisplay();
}

//----------------------------------------------------------------------------
// glowna funkcja programu
//----------------------------------------------------------------------------
int main(int argc, char** argv) {
	glutInit(&argc, argv);

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH | GLUT_STENCIL | GLUT_MULTISAMPLE);
	glutInitWindowSize(640, 480);
	glutInitWindowPosition(1, 1);
	glutCreateWindow(argv[0]);

	randomize(); //wlaczenie generatora liczb losowych: w niektorych kompilatorach C to moze nie dzialac

	fale_init();

	glutDisplayFunc(fale_display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(Keyboard);

	glutTimerFunc(40, OnTimer, 0);
	
	glutMainLoop();
	return 0;
}
