//-------------------------------------------------------------------------
//zmienne i stale

#define fale_wodarozm 100  //max. wymiary X i Z powierzchni wody, liczone w punktach siatki

int fale_il=90; //wymiary X i Z powierzchni wody, liczone w punktach siatki
float fale_krok=0.50;//wielkosc "kratki" wody, czyli odleglosc miedzy punktami siatki powierzchni
float fale_skalay=1.5; //skala wody w pionie (dzielone przez fale_skalay)
float fale_x0,fale_z0; //wspolrzedne X, Z miejsca, od ktorego zaczynamy rysowanie calej powierzchni wody

GLfloat fale_kolor_tla[] = {0.0, 0.0, 0.0, 1.0}; //kolor tla ekranu

int licznik; //licznik, ktory zwieksza sie ciagle; potrzebny do symulowania ruchu statkow

//struktura przechowujaca zmienne ustalajace zachowanie wody; mozna je zmieniac w trakcie dzialania programu!
struct 
{
     float gestosc1,gestosc2,gestosc3;
} fale_ust;

//siatka punktow powierzchni wody
struct 
{
	float y, dy;
	GLfloat norm[3]; //wektor normalny
} fale_woda[fale_wodarozm][fale_wodarozm];


//----------------------------------------------------------------------------
// ustawienie najwazniejszych rzeczy na poczatek
//----------------------------------------------------------------------------
void fale_init()
{
	int a, x, z;
    GLfloat ambient[] = { 1.0, 1.0, 1.0, 1.0 };
    GLfloat diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
    GLfloat specular[] = { 1.0, 1.0, 1.0, 1.0 };
    GLfloat position[] = { 100, 80, 0, 0.0 };

    GLfloat lmodel_ambient[] = { 0.3, 0.3, 0.3, 1.0 };

    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);

    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
    glLightfv(GL_LIGHT0, GL_POSITION, position);

    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
    glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);

    glFrontFace (GL_CCW);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
//    glEnable(GL_AUTO_NORMAL);
//    glEnable(GL_NORMALIZE);

    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);


	glFogi (GL_FOG_MODE, GL_EXP2);
	glFogfv (GL_FOG_COLOR, fale_kolor_tla);
	glFogf (GL_FOG_DENSITY, 0.009);
	glHint (GL_FOG_HINT, GL_NICEST);

    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();
 
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	wczytaj_teksture(0, "dno.bmp",0);
	wczytaj_teksture(1, "niebonrm.bmp",0);

	//ustawienie parametrow ruchu wody
	fale_ust.gestosc1 = 0.95; //0.98
	fale_ust.gestosc2 = 20; //50
	fale_ust.gestosc3 = 0.95; //0.98

	fale_x0=(fale_il/2.0)*fale_krok;
	fale_z0=(fale_il/2.0)*fale_krok;

	//pozycja docelowa kamery:
	kamera[0][0]=3;
	kamera[0][1]=6;
	kamera[0][2]=20;
	kamera[1][0]=0;
	kamera[1][1]=0;
	kamera[1][2]=0;
	kamera[2][0]=0;
	kamera[2][1]=1;
	kamera[2][2]=0;

	//pozycja poczatkowa kamery:
	jestkamera[0][0] = 0;
	jestkamera[0][1] = 20;
	jestkamera[0][2] = 200;
	jestkamera[1][0] = 0;
	jestkamera[1][1] = 0;
	jestkamera[1][2] = -50;
	jestkamera[2][0] = 0;
	jestkamera[2][1] = 0;
	jestkamera[2][2] = 0;

	szybkosckamery = 10;

}

//----------------------------------------------------------------------------
// wyswietlenie powierzchni wody
//----------------------------------------------------------------------------
void fale_rysuj_wode()
{
	GLfloat material_ka[] = {0.78, 0.83, 1.00, 0.2};
	GLfloat material_kd[] = {0.70, 0.75, 1.00, 0.8};
	GLfloat material_ks[] = {0.80, 0.80, 1.00, 1.0};

	float x,z,mn, px,pz,py;
	float przezroczystosc, kolr,kolg,kolb;
	float f;

	//kolor i przezroczystosc wody:
	przezroczystosc = 0.7;
	kolr = 0.8;
	kolg = 0.9;
	kolb = 1.0;

	//jesli chcemy widziec fale tylko z gory, warto ukryc "tylna" czesc powierzchni, zeby ograniczyc obliczenia
	//w przeciwnym wypadku pokazuj obie strony powierzchni wody
	glDisable(GL_CULL_FACE);

	glPushMatrix();
		glEnable(GL_BLEND);
		glDepthMask(GL_FALSE);
		glEnable(GL_COLOR_MATERIAL);
		glMaterialfv(GL_FRONT, GL_AMBIENT, material_ka);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, material_kd);
		glMaterialfv(GL_FRONT, GL_SPECULAR, material_ks);
		glMaterialf(GL_FRONT, GL_SHININESS, 70);

		wlacz_teksture_env(1);
		for (x=0; x<fale_il-1;x++) {
			glBegin(GL_TRIANGLE_STRIP);
				for (z=0;z<fale_il-1; z++) {

					glColor4f(	kolr, kolg, kolb, przezroczystosc);

					pz=z*fale_krok-fale_z0;

					if (x+1>=1 && z>=1 && x+1<=fale_il-1 && z<=fale_il-1)
					{
						glNormal3fv(fale_woda[(int)x+1][(int)z  ].norm);
					} else {
						glNormal3f(0, 1, 0);
					}
					
					px=(x+1)*fale_krok-fale_x0;

					if (x+1>=1 && z>=1 && x+1<=fale_il-1 && z<=fale_il-1)
					{
						py = fale_woda[(int)x+1][(int)z].y /fale_skalay;
					} else py=0;

					glVertex3f(px, py, pz);

					if (x>=1 && z>=1 && x<=fale_il-1 && z<=fale_il-1)
					{
						glNormal3fv(fale_woda[(int)x][(int)z  ].norm);
					} else {
						glNormal3f(0, 1, 0);
					}

					px=x*fale_krok-fale_x0;

					if (x>=1 && z>=1 && x<=fale_il-1 && z<=fale_il-1)
					{
						py = fale_woda[(int)x][(int)z  ].y /fale_skalay;
					} else py=0;
					
					glVertex3f(px, py, pz);

				}
			glEnd();
		}
		wylacz_teksture();

		glDisable(GL_COLOR_MATERIAL);
		glDepthMask(GL_TRUE);
		glDisable(GL_BLEND);

	glPopMatrix();
}

//----------------------------------------------------------------------------
// wyswietlenie dna pod woda, ktore jest modyfikowane podobnie jak fale, aby
// stworzyc pozory zakrzywiania patrzenia przez powierzchnie wody
// jezeli planujemy zrobic wejscie kamery pod wode, warto zmienic to tak, by
// pod woda obrazek jednak nie ulegal takim znieksztalceniom, jak widac
// ponad powierzchnia wody
//----------------------------------------------------------------------------
void fale_rysuj_obrazek(int tekstura)
{
	GLfloat material_ka[] = {0.7, 0.7, 0.7, 1.0};
	GLfloat material_kd[] = {0.7, 0.7, 0.7, 1.0};
	GLfloat material_ks[] = {0.7, 0.7, 0.7, 1.0};

	const float maxy=1; //max stopien znieksztalcenia obrazu dna

	float x,z,mn, px,pz, pxt,pzt, j, yy;

	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_AMBIENT, material_ka);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, material_kd);
		glMaterialfv(GL_FRONT, GL_SPECULAR, material_ks);
		glMaterialf(GL_FRONT, GL_SHININESS, 80);
		glEnable(GL_COLOR_MATERIAL);

		wlacz_teksture(tekstura);
		for (x=0; x<fale_il-1;x++) {
			glBegin(GL_TRIANGLE_STRIP);
				for (z=0;z<fale_il-1; z++) {

					j = 1-fabs(fale_woda[(int)x+1][(int)z].y/1.0);
					if (j<0.1) j=0.1;
					if (j>1) j=1;

					glColor3f( j,j,j);

					glNormal3f(0, 1, 0);

					yy = fale_woda[(int)x+1][(int)z].y;
					if (yy>maxy) yy=maxy;
					if (yy<-maxy) yy=-maxy;
					pz=z*fale_krok-fale_z0 + yy;
					pzt=fale_il-z;
				
					yy = fale_woda[(int)x+1][(int)z].y;
					if (yy>maxy) yy=maxy;
					if (yy<-maxy) yy=-maxy;
					px=(x+1)*fale_krok-fale_x0 + yy;
					pxt=(x+1);

					glTexCoord2f(pxt/fale_il,pzt/fale_il);
					glVertex3f(px, 0, pz);


					j = 1-fabs(fale_woda[(int)x][(int)z].y/1.0);
					if (j<0.1) j=0.1;
					if (j>1) j=1;

					glColor3f( j,j,j);

					yy = fale_woda[(int)x][(int)z].y;
					if (yy>maxy) yy=maxy;
					if (yy<-maxy) yy=-maxy;
					pz=z*fale_krok-fale_z0 + yy;
					pzt=fale_il-z;

					yy = fale_woda[(int)x][(int)z].y;
					if (yy>maxy) yy=maxy;
					if (yy<-maxy) yy=-maxy;
					px=x*fale_krok-fale_x0 + yy;
					pxt=x;
			
					glTexCoord2f(pxt/fale_il,pzt/fale_il);
					glVertex3f(px, 0, pz);
				}
			glEnd();
		}

		glDisable(GL_COLOR_MATERIAL);
		wylacz_teksture();

	glPopMatrix();
}


//----------------------------------------------------------------------------
// wyswietlenie wszystkiego na ekranie
//----------------------------------------------------------------------------
void fale_display()
{
	int a;

	glClearColor(fale_kolor_tla[0], fale_kolor_tla[1], fale_kolor_tla[2], 0.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glEnable(GL_FOG);

	glPushMatrix();
		glLoadIdentity();

		//kamera
		gluLookAt( jestkamera[0][0], jestkamera[0][1], jestkamera[0][2], 
					jestkamera[1][0], jestkamera[1][1], jestkamera[1][2], 
					jestkamera[2][0], jestkamera[2][1], jestkamera[2][2]);

		//rysuj dno
		glPushMatrix();
			glTranslatef(0,-5,0); //ustalenie glebokosci, czyli obnizenie poziomu dna
			fale_rysuj_obrazek(0);
		glPopMatrix();	

		//tu rysuj np. plywajace po wodzie statki

		//rysuj wode na koncu, poniewaz jest przezroczysta
		fale_rysuj_wode();
	glPopMatrix();

	glFlush();
	glutSwapBuffers();
}

// ------------------------------------------------------------------------
// ******************************* RUCH ***********************************
// ------------------------------------------------------------------------

// ------------------------------------------------------------------------
// ruch powierzchni wody
// ------------------------------------------------------------------------
void ruch_powierzchni()
{
	int a,b;
	GLfloat vek1[3],vek2[3],vek3[3];

	//ruch fal
	for (b=1; b<=fale_il-2; b++)
		for (a=1; a<=fale_il-2; a++) {
			if (fale_woda[b][a].y != fale_woda[b][a+1].y) 
				fale_woda[b][a].dy = fale_woda[b][a].dy+(fale_woda[b][a+1].y-fale_woda[b][a].y)/fale_ust.gestosc2;
			if (fale_woda[b][a].y != fale_woda[b][a-1].y) 
				fale_woda[b][a].dy = fale_woda[b][a].dy+(fale_woda[b][a-1].y-fale_woda[b][a].y)/fale_ust.gestosc2;
			if (fale_woda[b][a].y != fale_woda[b+1][a].y) 
				fale_woda[b][a].dy = fale_woda[b][a].dy+(fale_woda[b+1][a].y-fale_woda[b][a].y)/fale_ust.gestosc2;
			if (fale_woda[b][a].y != fale_woda[b-1][a].y) 
				fale_woda[b][a].dy = fale_woda[b][a].dy+(fale_woda[b-1][a].y-fale_woda[b][a].y)/fale_ust.gestosc2;
			fale_woda[b][a].y = fale_woda[b][a].y+fale_woda[b][a].dy;
			fale_woda[b][a].dy = fale_woda[b][a].dy*fale_ust.gestosc1;
			fale_woda[b][a].y = fale_woda[b][a].y*fale_ust.gestosc3;
		}


	//obliczanie normalnych powierzchni wody
	for (b=1; b<=fale_il-1; b++)
		for (a=1; a<=fale_il-1; a++) {
			vek1[0] = 1.0;
			vek1[1] = (fale_woda[(int)a+1][(int)b  ].y-fale_woda[(int)a  ][(int)b  ].y)/fale_skalay;
			vek1[2] = 0.0;

			vek2[0] = 0.0;
			vek2[1] = (fale_woda[(int)a  ][(int)b+1].y-fale_woda[(int)a  ][(int)b  ].y)/fale_skalay;
			vek2[2] = 1.0;

			cross_prod(vek2,vek1, vek3);
			
			fale_woda[a][b].norm[0]=vek3[0];
			fale_woda[a][b].norm[1]=vek3[1];
			fale_woda[a][b].norm[2]=vek3[2];
		}
}

// ------------------------------------------------------------------------
// rozne efekty na wodzie
// ------------------------------------------------------------------------
void efekty_wody()
{
	int a, x,z;

	//losowe krople deszczu
	fale_woda[rand()%fale_il][rand()%fale_il].dy -= 0.5;

	//statek
	licznik++;
	x = (sin( licznik/40.0 )*(fale_il/2.4)) + (fale_il/2.0);
	z = (cos( licznik/25.0 )*(fale_il/2.3)) + (fale_il/2.0);
	fale_woda[x][z].dy -= 0.7;


}

// ------------------------------------------------------------------------
// ruch kamery:
// - losowa zmiana jej pozycji,
// - obliczanie, jak kamera ma dazyc do wyznaczonego celu
// ------------------------------------------------------------------------
void ruch_kamery()
{
	int a,b;

	//losowa zmiana pozycji kamery
	if (rand()%200 == 0)
	{
		kamera[0][0]=rand()%60-30;
		kamera[0][1]=rand()%20-5;
		kamera[0][2]=rand()%60-30;

	}

	//ruch kamery
	for (a=0; a<=2; a++) {
		for (b=0; b<=2; b++) {
			if (jestkamera[a][b]!=kamera[a][b]) {
				jestkamera[a][b]=(jestkamera[a][b]*szybkosckamery + kamera[a][b])/(szybkosckamery+1);
			}
		}
	}

}

// ------------------------------------------------------------------------
void fale_ruch()
{	
	efekty_wody();
	ruch_powierzchni();
	ruch_kamery();
}
