//tekstury
BITMAPINFO	*BitmapInfo[30] = { NULL };	/* Current bitmap information */
void		*BitmapBits[30] = { NULL };	/* Current bitmap pixel bits */
static GLuint texName[20];

void wczytaj_teksture(int numer, char * nazwa, int jaka)
{
	void *bits;
	int wysokosc, szerokosc;
	int bajty;
	GLenum formt;

	if (!(bits = LoadBitmap(nazwa, &BitmapInfo[numer]))) exit(0);
	BitmapBits[numer] = ConvertRGB(BitmapInfo[numer], bits);
	free(bits);

	if (BitmapBits[numer] == NULL)
	{
		printf("Zla bitmapa. Nie mozna jej skonwertowac do RGB!");
		free(BitmapInfo[numer]);
		BitmapInfo[numer] = NULL;
	}

	szerokosc = BitmapInfo[numer]->bmiHeader.biWidth;
	wysokosc = BitmapInfo[numer]->bmiHeader.biHeight;
	bajty = 3;
	formt = GL_RGB;


	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
	glGenTextures(1, &texName[numer]);

	glBindTexture(GL_TEXTURE_2D, texName[numer]);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

	if (jaka==0) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
		else
	if (jaka==1) glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	if (jaka==1)
	{
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
		glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
		glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	}

	glTexImage2D(GL_TEXTURE_2D, 0, bajty,
			szerokosc,
			wysokosc,
			0, formt, GL_UNSIGNED_BYTE,
			BitmapBits[numer]);


	if (gluBuild2DMipmaps(GL_TEXTURE_2D, bajty, 
						szerokosc,
						wysokosc,
						formt, 
						GL_UNSIGNED_BYTE,
						BitmapBits[numer])
	 !=0)
		exit(1);
}

void wlacz_teksture_env(int numer)
{
	glBindTexture(GL_TEXTURE_2D, texName[numer]);

	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);

	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glEnable(GL_TEXTURE_2D);
}

void wlacz_teksture(int numer)
{
	glBindTexture(GL_TEXTURE_2D, texName[numer]);

	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
	glLightModeli(GL_LIGHT_MODEL_AMBIENT, GL_TRUE);
	glEnable(GL_TEXTURE_2D);
}


void wylacz_teksture()
{
	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glDisable(GL_TEXTURE_2D);
};


void usun_teksture(int numer)
{
	glDeleteTextures(1, &texName[numer]);
}